#include 	<avr/io.h>
#include 	<avr/interrupt.h>
#include 	<stdio.h>
#include 	<stdarg.h>
#include 	<string.h>
#include 	<stdlib.h>
#include 	<math.h>

#include 	"mydefs.h"
#include 	"printf.h"
#include 	"serial.h"


#include 	"p10.h"
#include 	"font10dot.h"

//---------------------------------------------------------------------------------//
void scan (int i)
{
	//set_low (LED_PORT,LED_OE);
 
	switch (i)       
	{
		case 0 : 	set_high (LED_PORT,B);
					set_high (LED_PORT,A);
					break;
					
		case 1 : 	set_high (LED_PORT,B);
					set_low  (LED_PORT,A);
					break;
					
		case 2 : 	set_low  (LED_PORT,B);
					set_high (LED_PORT,A);
					break;

		case 3 : 	set_low (LED_PORT,B);
					set_low (LED_PORT,A);
					break;
				
		default :
					break;
	}
}
//---------------------------------------------------------------------------------//
void send_data (uint8_t dat)
{
    char loop;
	
		for (loop = 0; loop < 8; loop++)
		{
			if (dat & 0x80)		set_low   (LED_PORT, DAT);
			else				set_high  (LED_PORT, DAT);
			set_high (LED_PORT, CLK); 	__asm__("nop\n\t"); 
			set_low  (LED_PORT, CLK);	__asm__("nop\n\t"); 
			dat = dat << 1;
		}
} 
//---------------------------------------------------------------------------------//
void stobe (void)
{
	set_high (LED_PORT,STB);  __asm__("nop\n\t"); 
	set_low  (LED_PORT, STB); __asm__("nop\n\t"); 	
}
//---------------------------------------------------------------------------------//
void show (struct screen buff)
{
	cli ();
	
	int k,j,i,l;
	
			for (k = 0; k < 4; k++)
			{
				for(j = 0; j < 8;j++)
				{
					for (i = 0;i < 4;i++)
						send_data(buff.display_buff[(3-i) * 4 + k][j]);
				}
				
				scan (3- k);
				stobe ();   
				set_high (LED_PORT, LED_OE); 
				for (l = 0; l < 400;l++)
					_delay_us (1);
				set_low (LED_PORT, LED_OE); 
			}
			
			
	sei ();		
}
//---------------------------------------------------------------------------------//
void Print_Font (int page,char *str)
{
	int 	i,j,
			y = 0,
			len;
			
	uint16_t ascii;
	
	
		len = strlen (str);
		
		//memset (display, 0, sizeof display);
		
		for (i = 0; i < len; i++)
		{
				
				ascii  =  str[i];
				ascii -=  ' ';
				ascii *=   12;
				for (j = 0; j < 12; j++)
				{
					display[page].display_buff[j+2][y] = pgm_read_byte (&fonts[ascii + j]);
				}
				y++;
		}
		
		
}
//---------------------------------------------------------------------------------//
//---------------------------------------------------------------------------------//	
		